//-	---------------------------------------------------------------------------
//-	Name: 		DropListData.cpp
//-
//-	Purpose:	This file provides the implementation of the class
//-				CDropListData.
//-
//-	Revisions:
//-	Date		Author		Change Summary
//-	---------	------		---------------------------------------------------
//-	09-30-99	Mklombardi@ Created & Released.
//-             netzero,net 
//-
//-	Notes:		None.
//-
//- Copyright : This software is NOT copyrighted.
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name is included. If 
// the source code in  this file is used in any commercial application 
// then acknowledgement must be made to the author of this file 
// (in whatever form you wish).
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability for any damage/loss of business that
// this product may cause.
//
// Expect bugs!
// 
// Please use and enjoy. Please let me know of any bugs/mods/improvements 
// that you have found/implemented and I will fix/incorporate them into this
// file. 
//
//-	---------------------------------------------------------------------------
// DropListData.cpp : implementation file
//

#include "stdafx.h"
#include "sdigrid.h"
#include "DropListData.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static char *StateNames[] = {"AL", "AK", "AR", "AZ", "CA",
							 "CO", "CT", "DC", "DE", "FL",
							 "GA", "HI", "IA", "ID", "IL",
							 "IN", "KS", "KY", "LA", "MA",
							 "MD", "ME", "MI", "MN", "MO",
							 "MS", "MT", "NE", "NH", "NJ",
							 "NM", "NV", "NY", "NC", "ND",
							 "OH", "OK", "OR", "PA", "RI", 
							 "SC", "SD", "TN", "TX", "UT",
							 "VA", "VT", "WA", "WI", "WV",
							 "WY", "Guam",     "Puerto Rico", "APO", "FPO"};

static char *countryNames[] = { "Algeria             ",
								"Argentina           ",
								"Australia           ",
								"Austria             ",
								"Barbados            ",
								"Belgium             ",
								"Brazil              ",
								"Canada              ",
								"Cayman Island       ",
								"Channel Islands     ",
								"China               ",
								"Chile               ",
								"Colombia            ",
								"Cost  Rica          ",
								"Czech Rep           ",
								"Cyprus              ",
								"Denmark             ",
								"Dominican Rep       ",
								"Ecuador             ",
								"Egypt               ",
								"Finland             ",
								"France              ",
								"Germany             ",
								"Greece              ",
								"Guatemala           ",
								"Hong Kong           ",
								"Hungary             ",
								"Indonesia           ",
								"India               ",
								"Ireland             ",
          						"Israel              ",
								"Italy               ",
								"Ivory Coast         ",
								"Japan               ",
								"Jamaica             ",
								"Kenya               ",
								"Korea, South        ",
								"Liechtenstein       ",
								"Luxembourg          ",
								"Malaysia            ",
								"Malta               ",
								"Mexico              ",
								"Morocco             ",
								"Netherlands         ",
								"Netherlands Antilles",
								"New Zealand         ",
								"Nigeria             ",
								"Norway              ",
								"Pakistan            ",
								"Panama              ",
								"Peru                ",
								"Philippines         ",
								"Poland              ",
								"Portugal            ",
								"Puerto Rico         ",
								"Russia              ",
								"Saudi Arabia        ",
								"Singapore           ",
								"Slovakia            ",
								"South Africa        ",
								"Spain               ",
								"Sweden              ",
								"Switzerland         ",
								"Taiwan              ",
								"Thailand            ",
								"Turkey              ",
								"United Arab E       ",
								"UK                  ",
								"USA                 ",
								"Uzbekistan          ",
								"Venezuela           ",
								"Vietnam             ",
								"Zaire               ",
								"Various             " };

// Currencies
static char *currencyNames[] = {"Argentina Peso - A ",
								"Australia - $A     ",
								"Austria - Sch      ",
								"Belgium - BF       ",
								"Brazil - Cr$       ",
								"Canada - Can$      ",
								"China  - RMBY      ",
								"Chile  - Ch$       ",
								"Colombia -Col$     ",
								"Czech Rep - Kcs    ",
								"Denmark - DKr      ",
								"Dominican Rep - DR$",
								"Ecuador - S/       ",
								"Egypt   - LE       ",
								"Ireland - IRPound  ",
								"Finland - Fmk      ",
								"France - FFr       ",
								"Germany - DM       ",
								"Greece - Dr        ",
								"Hong Kong - HK$    ",
								"Hungary - Ft       ",
								"Indonesia - Rp     ",
								"India - Re         ",
								"Israel - NIS       ",
								"Italy - Lira       ",
								"Japan - Yen        ",
								"Kenya - KSh        ",
								"Korea,South - Won  ",
								"Luxembourg - Lf    ",
								"Malaysia - M$      ",
								"Mexico - Peso      ",
								"Morocco - DH       ",
								"Netherlands - Gld  ",
								"New Zealand - NZ$  ",
								"Nigeria - Naira    ",
								"Norway - NKr       ",
								"Pakistan - PRp     ",
								"Peru - New Sol     ",
								"Poland - Zl        ",
								"Portugal - Esc     ",
								"Puerto Rico - US$  ",
								"Russia - Ruble     ",
								"Saudi Arabia - SRls",
								"Singapore - S$     ",
								"Slovakia - SC      ",
								"South Africa - SAR ",
								"Spain - Pta        ",
								"Sweden - SKr       ",
								"Switzerland - SFr  ",
								"Taiwan - NT$       ",
								"Thailand - Baht    ",
								"Turkey - LT        ",
								"United Arab E - Dh ",
								"UK - Pound         ",
								"USA - US$          ",
								"Venzuela - Bolivar ",
								"Vietnam - VND      " };

// Cities that have income taxes
static char *localityNames[] = {"Detroit      ",
								"Grand Rapids ",
								"New York City",
								"Yonkers      ",
								"Other        "    };

// Owner
static char *ownerNames[] = {"Taxpayer", "Spouse  ", "Joint   "};

//W-2 Box 13 codes
static char *W2Box13Codes[] = {"D", "E", "F", "G", "H", "P", "R", "S", "T"};

//Short long term investment
static char *ShortLongNames[] = {"Inherited @ 20%",
 								 "Inherited @ 28%",
 								 "LongTerm @ 20% ",
 								 "LongTerm @ 28% ",
 								 "ShortTerm      ",
								 "Dates Entered  "};
								 
//Yes - No table
static char *YesNoNames[] = {"Yes", "No "};

// Dividend investment types
static char *divNames[] = {"Regular   ", "Tax-exempt", "US Govt.  "};

// KEOGH types
static char *keoghNames[] = {"Defined Contrib", 
							 "Defined Benefit",
							 "Profit Sharing "};

/////////////////////////////////////////////////////////////////////////////
// CDropListData dialog


CDropListData::CDropListData(CWnd* pParent /*=NULL*/)
	: CDialog(CDropListData::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDropListData)
	m_DropListItems = _T("");
	//}}AFX_DATA_INIT
    m_ControlToSelect = -1;
}


void CDropListData::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDropListData)
	DDX_Control(pDX, IDC_DROP_LIST_DATA, m_EditBox);
	DDX_Text(pDX, IDC_DROP_LIST_DATA, m_DropListItems);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDropListData, CDialog)
	//{{AFX_MSG_MAP(CDropListData)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_COUNTRIES, OnCountries)
	ON_BN_CLICKED(IDC_CURRENCY, OnCurrency)
	ON_BN_CLICKED(IDC_STATES, OnStates)
	ON_BN_CLICKED(IDC_TAXPAYER_SPOUSE, OnTaxpayerSpouse)
	ON_BN_CLICKED(IDC_LOCALATIES, OnLocalaties)
	ON_BN_CLICKED(IDC_BOX13CODES, OnBox13codes)
	ON_BN_CLICKED(IDC_DIVIDENDS, OnDividends)
	ON_BN_CLICKED(IDC_YESNO, OnYesno)
	ON_BN_CLICKED(IDC_KEOGH, OnKeogh)
	ON_BN_CLICKED(IDC_SHORTLONGINVST, OnShortlonginvst)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDropListData message handlers

BOOL CDropListData::OnInitDialog() 
{
	CDialog::OnInitDialog();

    //Tell which radio control to go active;
    if (m_ControlToSelect != -1)
        GetDlgItem(m_ControlToSelect)->SendMessage(BM_SETCHECK, 1, 0);

    CenterWindow();
    SetTimer(3422, 100, NULL);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CDropListData::OnOK() 
{
    UpdateData(TRUE);
	CDialog::OnOK();
}

CString CDropListData::GetDropListData()
{
    return m_DropListItems;
}

void CDropListData::SetDropListData(CString DropListData)
{
    m_DropListItems = DropListData;

    //Set the drop list type;
    if (!m_DropListItems.IsEmpty())
    {
        int Spacer = m_DropListItems.Find(CRLF);

        if (Spacer != -1)
        {
            //Strip out 1 line from the CString;
            CString FirstEntry = m_DropListItems.Left(Spacer);

            if (FirstEntry.Find(StateNames[0]) != -1)
               m_ControlToSelect = IDC_STATES;

            else if (FirstEntry.Find(countryNames[0]) != -1)
                m_ControlToSelect = IDC_COUNTRIES;

            else if (FirstEntry.Find(currencyNames[0]) != -1)
                m_ControlToSelect = IDC_CURRENCY;

            else if (FirstEntry.Find(localityNames[0]) != -1)
                m_ControlToSelect = IDC_LOCALATIES;

            else if (FirstEntry.Find(ownerNames[0]) != -1)
                m_ControlToSelect = IDC_TAXPAYER_SPOUSE;

            else if (FirstEntry.Find(W2Box13Codes[0]) != -1)
                m_ControlToSelect = IDC_BOX13CODES;

            else if (FirstEntry.Find(YesNoNames[0]) != -1)
                m_ControlToSelect = IDC_YESNO;

            else if (FirstEntry.Find(divNames[0]) != -1)
                m_ControlToSelect = IDC_DIVIDENDS;
                
            else if (FirstEntry.Find(keoghNames[0]) != -1)
                m_ControlToSelect = IDC_KEOGH;

           else if (FirstEntry.Find(ShortLongNames[0]) != -1)
                m_ControlToSelect = IDC_SHORTLONGINVST;
        }
    }
}

void CDropListData::OnTimer(UINT nIDEvent) 
{
    KillTimer(nIDEvent);	
	CDialog::OnTimer(nIDEvent);
    m_EditBox.SetFocus();
}

void CDropListData::OnStates() 
{
    m_DropListItems.Empty();

	//Loop for all elements;
	for (int Index = 0; Index < sizeof (StateNames)/sizeof (StateNames[0]); Index++)
    {
		//Add strings to the listbox;
		m_DropListItems += StateNames[Index];
        m_DropListItems += CRLF;
    }
	
    UpdateData(FALSE);
}

void CDropListData::OnCountries() 
{
    m_DropListItems.Empty();

	//Loop for all elements;
	for (int Index = 0; Index < sizeof (countryNames)/sizeof (countryNames[0]); Index++)
    {
		//Add strings to the listbox;
		m_DropListItems += countryNames[Index];
        m_DropListItems += CRLF;
    }
	
    UpdateData(FALSE);
}

void CDropListData::OnCurrency() 
{
    m_DropListItems.Empty();

	//Loop for all elements;
	for (int Index = 0; Index < sizeof (currencyNames)/sizeof (currencyNames[0]); Index++)
    {
		//Add strings to the listbox;
		m_DropListItems += currencyNames[Index];
        m_DropListItems += CRLF;
    }
	
    UpdateData(FALSE);
}

void CDropListData::OnTaxpayerSpouse() 
{
    m_DropListItems.Empty();

	//Loop for all elements;
	for (int Index = 0; Index < sizeof (ownerNames)/sizeof (ownerNames[0]); Index++)
    {
		//Add strings to the listbox;
		m_DropListItems += ownerNames[Index];
        m_DropListItems += CRLF;
    }
	
    UpdateData(FALSE);
}

void CDropListData::OnLocalaties() 
{
    m_DropListItems.Empty();

	//Loop for all elements;
	for (int Index = 0; Index < sizeof (localityNames)/sizeof (localityNames[0]); Index++)
    {
		//Add strings to the listbox;
		m_DropListItems += localityNames[Index];
        m_DropListItems += CRLF;
    }
	
    UpdateData(FALSE);
}

void CDropListData::OnBox13codes() 
{
    m_DropListItems.Empty();

	//Loop for all elements;
	for (int Index = 0; Index < sizeof (W2Box13Codes)/sizeof (W2Box13Codes[0]); Index++)
    {
		//Add strings to the listbox;
		m_DropListItems += W2Box13Codes[Index];
        m_DropListItems += CRLF;
    }
	
    UpdateData(FALSE);	
}

void CDropListData::OnDividends() 
{
    m_DropListItems.Empty();

	//Loop for all elements;
	for (int Index = 0; Index < sizeof (divNames)/sizeof (divNames[0]); Index++)
    {
		//Add strings to the listbox;
		m_DropListItems += divNames[Index];
        m_DropListItems += CRLF;
    }
	
    UpdateData(FALSE);
}

void CDropListData::OnYesno() 
{
    m_DropListItems.Empty();

	//Loop for all elements;
	for (int Index = 0; Index < sizeof (YesNoNames)/sizeof (YesNoNames[0]); Index++)
    {
		//Add strings to the listbox;
		m_DropListItems += YesNoNames[Index];
        m_DropListItems += CRLF;
    }
	
    UpdateData(FALSE);
}

void CDropListData::OnKeogh() 
{
    m_DropListItems.Empty();

	//Loop for all elements;
	for (int Index = 0; Index < sizeof (keoghNames)/sizeof (keoghNames[0]); Index++)
    {
		//Add strings to the listbox;
		m_DropListItems += keoghNames[Index];
        m_DropListItems += CRLF;
    }
	
    UpdateData(FALSE);
}

void CDropListData::OnShortlonginvst() 
{
    m_DropListItems.Empty();

	//Loop for all elements;
	for (int Index = 0; Index < sizeof (ShortLongNames)/sizeof (ShortLongNames[0]); Index++)
    {
		//Add strings to the listbox;
		m_DropListItems += ShortLongNames[Index];
        m_DropListItems += CRLF;
    }
	
    UpdateData(FALSE);	
}
