//-	---------------------------------------------------------------------------
//-	Name: 		InPlaceCheckbox.h
//-
//-	Purpose:	This file provides the definition of the class
//-				CGridCheckBox.
//-
//-	Revisions:
//-	Date		Author		Change Summary
//-	---------	------		---------------------------------------------------
//-	09-30-99	Mklombardi@ Created & Released.
//-             netzero,net 
//-
//-	Notes:		None.
//-
//- Copyright : This software is NOT copyrighted.
// This code may be used in compiled form in any way you desire. This
// file may be redistributed unmodified by any means PROVIDING it is 
// not sold for profit without the authors written consent, and 
// providing that this notice and the authors name is included. If 
// the source code in  this file is used in any commercial application 
// then acknowledgement must be made to the author of this file 
// (in whatever form you wish).
//
// This file is provided "as is" with no expressed or implied warranty.
// The author accepts no liability for any damage/loss of business that
// this product may cause.
//
// Expect bugs!
// 
// Please use and enjoy. Please let me know of any bugs/mods/improvements 
// that you have found/implemented and I will fix/incorporate them into this
// file. 
#if !defined(AFX_INPLACECHECKBOX_H__ECD42822_16DF_11D1_992F_895E185F9C72__INCLUDED_)
#define AFX_INPLACECHECKBOX_H__ECD42822_16DF_11D1_992F_895E185F9C72__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#define IDC_CHECKBOXEDIT 1004

/////////////////////////////////////////////////////////////////////////////
// CGridCheckBox window

class CGridCheckBox : public CButton
{
// Construction
public:
	CGridCheckBox();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGridCheckBox)
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGridCheckBox();

	// Generated message map functions
protected:
	//{{AFX_MSG(CGridCheckBox)
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CInPlaceCheckbox window

class CInPlaceCheckbox : public CButton
{
    friend class CGridCheckBox;

// Construction
public:
	CInPlaceCheckbox(CWnd* pParent,         // parent
                 CRect& rect,           // dimensions & location
                 DWORD dwStyle,         // window/combobox style
                 UINT nID,              // control ID
                 int nRow, int nColumn, // row and column
                 CString sInitText,     // initial selection
				 UINT nFirstChar,
                 COLORREF BkColor);      // first character to pass to control

// Attributes
public:
   CGridCheckBox m_Checkbox;  // subclassed button control
   void ChangePosition(const CRect NewRect);
   void SetCheckState(BOOLEAN NewState);
   BOOLEAN GetCheckState();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CInPlaceCheckbox)
	protected:
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CInPlaceCheckbox();
protected:
    void EndEdit();

// Generated message map functions
protected:
	//{{AFX_MSG(CInPlaceCheckbox)
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnClicked();
	afx_msg HBRUSH CtlColor(CDC* pDC, UINT nCtlColor);
	//}}AFX_MSG

	DECLARE_MESSAGE_MAP()

private:
	int		m_nNumLines;
	CString m_sInitText;
	int		m_nRow;
	int		m_nCol;
 	UINT    m_nLastChar; 
	BOOL	m_bExitOnArrows; 
    COLORREF m_BkColor;
    CBrush	m_BackGndBrush;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_INPLACECHECKBOX_H__ECD42822_16DF_11D1_992F_895E185F9C72__INCLUDED_)
